const tdUrl = "https://platform.talk-deck.com";
const container = document.querySelector("#container");
let containerWidth = 0;
let fullscreen = document.getElementById("pFullscreen");
var isFullScreenPresentation = false;
let controls = document.getElementById("controls");
let slidelistBtn = document.getElementById("slidelist-btn");
let slidelistSwitchOn = document.getElementById("slidelist-switch-on");
let slidelistSwitchOff = document.getElementById("slidelist-switch-off");
let slidelist = document.getElementById("slidelist");
let slidelistlabel = document.getElementById("slidelist-label");
let slidelistBtnlabel = document.getElementById("slidelist-btn-lbl");
let videoTimeLabel = document.getElementById("videoTimeLabel");
let progressControl = document.getElementById("progressControl");
let blockShareSwitch = false;
let btnRequest = document.getElementById("request-btn");
let btnTitleSubscribe = document.getElementById("pTitleSubscribe");
let blockRequest = document.getElementById("requestBlock");
let requestClose = document.getElementById("requestClose");
let requestSend = document.getElementById("requestSend");
let sendRequestInfo = document.getElementById("sendRequestInfo");
let blockRequestSwitch = false;
let progressLine = document.getElementById("progress");
let ctrVideoPlay = document.getElementById("ctrVideoPlay");
let ctrVideoPause = document.getElementById("ctrVideoPause");
let ctrVideoVolume = document.getElementById("ctrVideoVolume");
let ctrVideoMute = document.getElementById("ctrVideoMute");
let presentationRequest = {};
var bigPlayButtonGo = true;
var st = [];
var str = [];
let csvTml;
var tml = [];
var autoSlidelistShowTime = 10000;
var autoSlidelistHideTime = 20000;
var autoSlidelistShowTimeOut;
var autoSlidelistHideTimeOut;
const video = document.querySelector("video");
var progressControlWidth = 0;
slidelistBtn.onclick = function() {
    elmShowHideSlidelist(slidelist);
    if (!slidelistlabel.classList.contains("dsp-none")) {
			slidelistlabel.classList.add("dsp-none")
    }
    if (slidelistBtnlabel.classList.contains("dsp-none")) {
			slidelistBtnlabel.classList.remove("dsp-none")
    }
		try {
			clearTimeout(autoSlidelistShowTimeOut);
			clearTimeout(autoSlidelistHideTimeOut);
		} catch(err) {
		}
};
slidelistSwitchOn.onclick = function() {
    elmShowHideSlidelist(slidelist);
    if (!slidelistlabel.classList.contains("dsp-none")) {
			slidelistlabel.classList.add("dsp-none")
    }
    if (slidelistBtnlabel.classList.contains("dsp-none")) {
			slidelistBtnlabel.classList.remove("dsp-none")
    }
		try {
			clearTimeout(autoSlidelistShowTimeOut);
			clearTimeout(autoSlidelistHideTimeOut);
		} catch(err) {
		}
};
slidelistSwitchOff.onclick = function() {
    elmShowHideSlidelist(slidelist);
    if (!slidelistlabel.classList.contains("dsp-none")) {
			slidelistlabel.classList.add("dsp-none")
    }
    if (slidelistBtnlabel.classList.contains("dsp-none")) {
			slidelistBtnlabel.classList.remove("dsp-none")
    }
		try {
			clearTimeout(autoSlidelistShowTimeOut);
			clearTimeout(autoSlidelistHideTimeOut);
		} catch(err) {
		}
};
function autoShowSlideList() {
	elmShowHideSlidelist(slidelist);
}
function autoFadeFlashSlideListButton() {
	if (!slidelistlabel.classList.contains("dsp-none")) {
			slidelistlabel.classList.add("dsp-none")
	}
	if (slidelistBtnlabel.classList.contains("dsp-none")) {
			slidelistBtnlabel.classList.remove("dsp-none")
	}
}
function elmShowHide(elm) {
    if (elm.classList.contains("dsp-none")) {
        elm.classList.remove("dsp-none")
    } else {
        elm.classList.add("dsp-none")
    }
}
function elmShowHideSlidelist(elm) {
    if (elm.classList.contains("dsp-none")) {
        elm.classList.remove("dsp-none");
				slidelistlabel.innerHTML = "Close Slidelist";
				if(!slidelistlabel.classList.contains("slidelist-label-blue")) {
					slidelistlabel.classList.add("slidelist-label-blue");
				}
				slidelistBtnlabel.innerHTML = "Close Slidelist";
    } else {
        elm.classList.add("dsp-none");
				slidelistlabel.innerHTML = "Open Slidelist";
				if(slidelistlabel.classList.contains("slidelist-label-blue")) {
					slidelistlabel.classList.remove("slidelist-label-blue");
				}
				slidelistBtnlabel.innerHTML = "Open Slidelist";
    }
}
ctrVideoVolume.onclick = function() {
    if (!video.muted) {
        video.muted = true;
        video.volume = 0;
        if (!ctrVideoVolume.classList.contains("dsp-none")) {
            ctrVideoVolume.classList.add("dsp-none")
        }
        if (ctrVideoMute.classList.contains("dsp-none")) {
            ctrVideoMute.classList.remove("dsp-none")
        }
    }
};
ctrVideoMute.onclick = function() {
    if (video.muted) {
        video.muted = false;
        video.volume = 1;
        if (!ctrVideoMute.classList.contains("dsp-none")) {
            ctrVideoMute.classList.add("dsp-none")
        }
        if (ctrVideoVolume.classList.contains("dsp-none")) {
            ctrVideoVolume.classList.remove("dsp-none")
        }
    }
};
ctrVideoPlay.onclick = function() {
    video.play();
    if (!ctrVideoPlay.classList.contains("dsp-none")) {
        ctrVideoPlay.classList.add("dsp-none")
    }
    if (ctrVideoPause.classList.contains("dsp-none")) {
        ctrVideoPause.classList.remove("dsp-none")
    }
};
ctrVideoPause.onclick = function() {
    video.pause();
    if (!ctrVideoPause.classList.contains("dsp-none")) {
        ctrVideoPause.classList.add("dsp-none")
    }
    if (ctrVideoPlay.classList.contains("dsp-none")) {
        ctrVideoPlay.classList.remove("dsp-none")
    }
};
video.addEventListener("timeupdate", function() {
    videoTimeLabelRefresh(video);
    autoActiveSlide();
});
progressControl.onclick = function(event) {
    var mx = event.offsetX;
    var jt = mx * video.duration / progressControlWidth;
    video.currentTime = jt
};
btnRequest.onclick = function() {
	if(blockShareSwitch) {
		blockShareSwitch = false;
		blockShare.style.display = "none";
	}
	if(!blockRequestSwitch) {
		blockRequestSwitch = true;
		blockRequest.style.display = "inline-block";
	}
};
btnTitleSubscribe.onclick = function() {
	if(blockShareSwitch) {
		blockShareSwitch = false;
		blockShare.style.display = "none";
	}
	if(!blockRequestSwitch) {
		blockRequestSwitch = true;
		blockRequest.style.display = "inline-block";
	}
};
requestClose.onclick = function() {
	if(blockRequestSwitch) {
		blockRequestSwitch = false;
		blockRequest.style.display = "none";
		clearRequestForm();
	}
};
requestSend.onclick = function() {
	presentationRequest.fname = document.getElementById("requestName").value;
	presentationRequest.phonecontact = document.getElementById("requestContactPhone").value;
	presentationRequest.emailcontact = document.getElementById("requestContactEmail").value;
	presentationRequest.maillinglist = document.getElementById("requestMailingListEmail").value;
	presentationRequest.presidentlist = document.getElementById("requestPresidentListEmail").value;
	if(!presentationRequest.fname) {
		sendRequestInfo.style.color = "#970000";
		sendRequestInfo.style.background = "#ffdbe1";
		sendRequestInfo.innerHTML = "";
		sendRequestInfo.innerHTML = "Fill fullname please!";
		sendRequestInfo.style.visibility = "visible";
		return;
	}
	if(!presentationRequest.phonecontact && !presentationRequest.emailcontact && !presentationRequest.maillinglist && !presentationRequest.presidentlist) {
		sendRequestInfo.style.color = "#970000";
		sendRequestInfo.style.background = "#ffdbe1";
		sendRequestInfo.innerHTML = "";
		sendRequestInfo.innerHTML = "Fill minimum one option please!";
		sendRequestInfo.style.visibility = "visible";
		return;
	}
	const formData = new FormData();
	formData.append("rqt", JSON.stringify(presentationRequest));
	const xhr = new XMLHttpRequest();
  xhr.addEventListener("load", (event) => {
		if(event.currentTarget.response == "ok") {
				sendRequestInfo.style.color = "#002e00";
				sendRequestInfo.style.background = "#c6e3ca";
				sendRequestInfo.innerHTML = "";
				sendRequestInfo.innerHTML = "Subscribe request is sent.";
				sendRequestInfo.style.visibility = "visible";
		} else {
				sendRequestInfo.style.color = "#970000";
				sendRequestInfo.style.background = "#ffdbe1";
				sendRequestInfo.innerHTML = "";
				sendRequestInfo.innerHTML = "Error!";
				sendRequestInfo.style.visibility = "visible";
		}
  });
  xhr.addEventListener("error", (event) => {
		sendRequestInfo.style.color = "#970000";
		sendRequestInfo.style.background = "#ffdbe1";
		sendRequestInfo.innerHTML = "";
		sendRequestInfo.innerHTML = "Error!";
		sendRequestInfo.style.visibility = "visible";
  });
  xhr.open("POST", tdUrl + "/api/playback/presentation-request.php");
  xhr.send(formData);
};
document.getElementById("requestName").onclick = function() {
	clearRequestFormInfo();
}
document.getElementById("requestContactPhone").onclick = function() {
	clearRequestFormInfo();
}
document.getElementById("requestContactEmail").onclick = function() {
	clearRequestFormInfo();
}
document.getElementById("requestMailingListEmail").onclick = function() {
	clearRequestFormInfo();
}
document.getElementById("requestPresidentListEmail").onclick = function() {
	clearRequestFormInfo();
}
function clearRequestForm() {
	sendRequestInfo.style.visibility = "hidden";
	clearRequestFormFields();
}
function clearRequestFormFields() {
	document.getElementById("requestName").value = "";
	document.getElementById("requestContactPhone").value = "";
	document.getElementById("requestContactEmail").value = "";
	document.getElementById("requestMailingListEmail").value = "";
	document.getElementById("requestPresidentListEmail").value = "";
}
function clearRequestFormInfo() {
	sendRequestInfo.style.visibility = "hidden";
}
fullscreen.onclick = function() {
    try {
        if (!isFullScreenPresentation) {
            try {
                document.documentElement.requestFullscreen()
            } catch (er) {}
            document.documentElement.webkitRequestFullScreen();
            element.webkitRequestFullScreen();
            document.documentElement.webkitEnterFullscreen()
        } else {
            try {
                if (document.exitFullscreen) {
                    document.exitFullscreen();
                    document.webkitCancelFullScreen()
                }
            } catch (er) {}
            document.webkitCancelFullScreen()
        }
    } catch (err) {}
};
function outFullscreen() {
	try {
		if (isFullScreenPresentation) {
			try {
					if (document.exitFullscreen) {
							document.exitFullscreen();
							document.webkitCancelFullScreen();
					}
			} catch (er) {}
			document.webkitCancelFullScreen();
		}
	} catch (err) {}
}
function videoGoFullscreen() {
  if (video.requestFullscreen) {
			video.requestFullscreen();
  } else if (video.webkitRequestFullscreen) {
			video.webkitRequestFullscreen();
  } else if (video.msRequestFullscreen) {
			video.msRequestFullscreen();
  }
}
function activeSlide(elm) {
    event.preventDefault();
    if (bigPlayButtonGo) {
        if (!document.getElementById("bPlayButtonW").classList.contains("dsp-none")) {
            document.getElementById("bPlayButtonW").classList.add("dsp-none");
            bigPlayButtonGo = false;
        }
    }
    var vTime = elm.dataset.slidetime;
    video.currentTime = vTime;
    video.play();
    if (!ctrVideoPlay.classList.contains("dsp-none")) {
        ctrVideoPlay.classList.add("dsp-none")
    }
    if (ctrVideoPause.classList.contains("dsp-none")) {
        ctrVideoPause.classList.remove("dsp-none")
    }
}
function autoActiveSlide() {
    for (var i = 0; i < str.length; i++) {
        if (video.currentTime >= str[i]) {
            var sid = "sld" + str[i];
            var slidelistSelected = document.querySelectorAll("a.selected");
            if (slidelistSelected[0].classList.contains("selected")) {
                slidelistSelected[0].classList.remove("selected")
            }
            if (!document.getElementById(sid).classList.contains("selected")) {
                document.getElementById(sid).classList.add("selected")
            }
            break
        }
    }
}
function s2hmmss(s) {
    var h = Math.floor(s / 3600);
    var m = Math.floor((s - h * 3600) / 60);
    var s = s - h * 3600 - m * 60;
    s = Math.round(s);
    if (s == 60) {
        s = 0;
        m = m + 1
    }
    if (m == 60) {
        m = 0
    }
    var r = h;
    r += ":" + (m < 10 ? "0" + m : m);
    r += ":" + (s < 10 ? "0" + s : s);
    return r
}
function videoTimeLabelRefresh(v) {
    videoTimeLabel.innerText = s2hmmss(v.currentTime);
    var progressPercentage = 100 / v.duration * v.currentTime;
    progressLine.style.width = progressPercentage + "%"
}
function hms2s(hms) {
    var t = hms.split(":");
    var s = +t[0] * 60 * 60 + +t[1] * 60 + +t[2];
    return s
}
function fPlay() {
    if (!document.getElementById("bPlayButtonW").classList.contains("dsp-none")) {
        document.getElementById("bPlayButtonW").classList.add("dsp-none")
    }
    video.play();
    if (!ctrVideoPlay.classList.contains("dsp-none")) {
        ctrVideoPlay.classList.add("dsp-none")
    }
    if (ctrVideoPause.classList.contains("dsp-none")) {
        ctrVideoPause.classList.remove("dsp-none")
    }
		slidelistlabel.innerHTML = "Open Slidelist";
		autoSlidelistShowTimeOut = setTimeout(autoShowSlideList, autoSlidelistShowTime);
		autoSlidelistHideTimeOut = setTimeout(autoShowSlideList, autoSlidelistHideTime);
}
function loadTimelineCSV() {
    csvTml = document.getElementById("timeline-csv").value;
    csvData(csvTml.trim())
}
function csvData(t) {
    var allTextLines = t.split(/\r\n|\n/);
    var headers = allTextLines[0].split(",");
    var lines = [];
    for (var i = 1; i < allTextLines.length; i++) {
        var data = allTextLines[i].split(",");
        if (data.length == headers.length) {
            var tarr = [];
            for (var j = 0; j < headers.length; j++) {
                var pt = data[j].substring(1);
                var pts = pt.slice(0, -1);
                tarr[headers[j]] = pts
            }
            lines.push(tarr)
        }
    }
    tml = lines;
    addTimeline(tml)
}
function addTimeline(o) {
    var ae = "";
    var i = 1;
    var slidesInLi = document.getElementsByClassName("slide-inli");
    for (var n = 0; n < slidesInLi.length; n++) {
        var slideInLi = slidesInLi[n];
        st[i - 1] = slideInLi.dataset.slidetime;
        i++
    }
    Object.keys(st).forEach(function(i) {
        str[i] = st[st.length - 1 - i]
    })
}
function isFullScreenPresentationDdetector() {
    if (isFullScreenPresentation) {
        isFullScreenPresentation = false
    } else {
        isFullScreenPresentation = true
    }
}
document.addEventListener("fullscreenchange", function() {
    isFullScreenPresentationDdetector()
});
document.addEventListener("mozfullscreenchange", function() {
    isFullScreenPresentationDdetector()
});
document.addEventListener("webkitfullscreenchange", function() {
    isFullScreenPresentationDdetector()
});
document.addEventListener("msfullscreenchange", function() {
    isFullScreenPresentationDdetector()
});
window.addEventListener("resize", function(event) {
    progressControlWidth = progressControl.clientWidth;
		containerWidth = container.clientWidth;
});
document.addEventListener("DOMContentLoaded", function() {
    progressControlWidth = progressControl.clientWidth;
		containerWidth = container.clientWidth;
    loadTimelineCSV()
}, false);
let touchstartX = 0;
let touchendX = 0;
const slider = document.getElementById("container");
function handleGesture() {
    if (touchendX < touchstartX - 100) {
        if (slidelist.classList.contains("dsp-none")) {
            slidelist.classList.remove("dsp-none")
        }
    }
    if (touchendX > touchstartX + 100) {
        if (!slidelist.classList.contains("dsp-none")) {
            slidelist.classList.add("dsp-none")
        }
    }
}
slider.addEventListener("touchstart", e => {
    touchstartX = e.changedTouches[0].screenX
});
slider.addEventListener("touchmove", e => {
    touchendX = e.changedTouches[0].screenX;
    handleGesture()
});
slider.addEventListener("touchend", e => {
    touchstartX = 0;
    touchendX = 0
});
if(searchParams.get("jt") !== null) {
	var jt = searchParams.get("jt");
	if (!video.muted) {
			video.muted = true;
			video.volume = 0;
			if (!ctrVideoVolume.classList.contains("dsp-none")) {
					ctrVideoVolume.classList.add("dsp-none")
			}
			if (ctrVideoMute.classList.contains("dsp-none")) {
					ctrVideoMute.classList.remove("dsp-none")
			}
	}
	fPlay();
	video.currentTime = jt;
	elmShowHide(slidelist);
	if (!slidelistlabel.classList.contains("dsp-none")) {
			slidelistlabel.classList.add("dsp-none")
	}
	if (slidelistBtnlabel.classList.contains("dsp-none")) {
			slidelistBtnlabel.classList.remove("dsp-none")
	}
}
window.onload = () => {
	presentationRequest.uid = container.getAttribute('data-uid');
	presentationRequest.surl = container.getAttribute('data-surl');
	presentationRequest.pid = container.getAttribute('data-pid');
	presentationRequest.uf = container.getAttribute('data-uf');
};
let maxwidth = window.matchMedia("(max-width: 1024px)")
let orientation = "landscape";
function checkWidthOrientation(w, o) {
	console.log("Function check width and orientation");
  if(w.matches && o == "portrait") {
			console.log("Max width 1024px and orientation", o);
			video.controls = true;
  } else if(w.matches && o == "landscape") {
			console.log("Max width 1024px and orientation", o);
			video.controls = true;
	} else {
			console.log("More than max width 1024px and orientation", o);
			video.controls = false;
  }
}
window.addEventListener("load", () => {
    if (window.matchMedia("(orientation: portrait)").matches) {
				orientation = "portrait";
        console.log("You are in - ", orientation);
    } else {
				orientation = "landscape";
        console.log("You are in - ", orientation);
    }
		checkWidthOrientation(maxwidth, orientation);
});
window.matchMedia("(orientation: portrait)").addEventListener("change", e => {
    const portrait = e.matches;
    if (portrait) {
				orientation = "portrait";
        console.log("You are in - ", orientation);
    } else {
				orientation = "landscape";
        console.log("You are in - ", orientation);
    }
		checkWidthOrientation(maxwidth, orientation);
});